#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir%
SetDefaultMouseSpeed, 0
SetTitleMatchMode, 3        ;Exact window title match
ATITDWindow:="eGenesis Client ahk_class eGenesis Client"

;Offsets from bottom left corner
;
;Add wood -   +36, -25
;Add water -  +85, -25
;Vent low -   +131, -25
;Vent med -   +156, -25
;Vent high -  +181, -25

;TODO:
;recovery on error

DebugMode:=0
Ovens:=0

;Find game window(s)
While (WindowHandle == "" || WindowHandle == 0)
{
  WinWait, %ATITDWindow%
  WinGet, WindowHandle, List, %ATITDWindow%
  If (A_Index > 50)
  {
    MsgBox, Error detecting ATITD Window.
    return
  }
}
If (%WindowHandle% > 1)
{
  MsgBox, Multiple game windows found. Multiple clients not supported.
}
WinGetPos, WinPosX, WinPosY, WindowWidth, WindowHeight, ahk_id %WindowHandle1%

;Here we sync to the window.
WinWaitActive, %ATITDWindow%
ImageSearch, FoundX, FoundY, 0, 0, WindowWidth, WindowHeight, *5 pyramid_small.png
If (ErrorLevel == 2)
{
  MsgBox, pyramid_small.png: Error opening file.
  return
}
Else If (ErrorLevel == 0)
{
  TopRightX:=FoundX+18
  TopRightY:=FoundY-31
}
Else If (ErrorLevel == 1)
{
  MsgBox, Could not detect game area. Make sure the small pyramid icon is in upper right corner and then reload the script.
  return
}

ImageSearch, FoundX, FoundY, 0, 0, WindowWidth, WindowHeight, *60 skills_bottom.png
If (ErrorLevel == 2)
{
  MsgBox, skills_bottom.png: Error opening file.
  return
}
If (ErrorLevel == 1)
{
  MsgBox, Could not detect game area. Make sure your skills window is not minimized then reload the script.
  return
}
If (ErrorLevel == 0)
{
  BottomLeftX:=FoundX - 4
  BottomLeftY:=FoundY + 9
}

BorderX:=WindowWidth - TopRightX - 1
BorderY:=WindowHeight - BottomLeftY - 1
GameWidth:=WindowWidth - 2*BorderX
GameHeight:=WindowHeight - TopRightY - BorderY
TopLeftX:=BorderX
TopLeftY:=TopRightY

SearchStartX:=0
SearchStartY:=0
OvenFile1:="charcoal_oven.png"
OvenFile2:="charcoal_hearth.png"
While (SearchStartY <= WindowHeight - 150)
{
  ImageSearch, FoundX, FoundY, SearchStartX, SearchStartY, WindowWidth, WindowHeight - 150, *60 this_is.png
  If (ErrorLevel == 2)
  {
    MsgBox, this_is.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    break
  }
  ;If we got this far we must've found a window. Let's see if it's a Charcoal Oven or Charcoal Hearth or neither.
  Loop, 2
  {
    CurrentFile:=OvenFile%A_Index%
    ImageSearch, , , FoundX, FoundY, FoundX + 200, FoundY + 30, *60 %CurrentFile%
    If (ErrorLevel == 2)
    {
      MsgBox, %CurrentFile%: Error opening file or invalid search parameters.
      return
    }
    Else If (ErrorLevel == 1)
    {
      continue
    }
    ;ErrorLevel == 0
    Ovens++
    OvenX%Ovens%:=FoundX
    OvenY%Ovens%:=FoundY
    break
  }
  ;Now we find all windows on the same line as the one we found
  SearchStartX2:=FoundX + 1
  SearchStartY2:=FoundY
  While (SearchStartX2 <= WindowWidth)
  {
    ImageSearch, FoundX2, FoundY2, SearchStartX2, SearchStartY2, WindowWidth, SearchStartY2 + 22, *60 this_is.png
    If (ErrorLevel == 2)
    {
      MsgBox, this_is.png: Error opening file or invalid search parameters.
      return
    }
    If (ErrorLevel == 1)
    {
      break
    }
    ;ErrorLevel == 0
    ;If we got this far we must've found a window. Let's see if it's a Charcoal Oven or Charcoal Hearth or neither.
    Loop, 2
    {
      CurrentFile:=OvenFile%A_Index%
      ImageSearch, , , FoundX2, FoundY2, FoundX2 + 200, FoundY2 + 30, *60 %CurrentFile%
      If (ErrorLevel == 2)
      {
        MsgBox, %CurrentFile%: Error opening file or invalid search parameters.
        return
      }
      Else If (ErrorLevel == 1)
      {
        continue
      }
      ;ErrorLevel == 0
      Ovens++
      OvenX%Ovens%:=FoundX2
      OvenY%Ovens%:=FoundY2
      break
    }
    SearchStartX2:=FoundX2 + 1
  }
  SearchStartY:=FoundY + 1
}

While (DebugMode == 1 && A_Index <= Ovens)
{
  ToolTip, %A_Index%, OvenX%A_Index%, OvenY%A_Index%, A_Index
  Temp1:=OvenX%A_Index%
  Temp2:=OvenY%A_Index%
  FileAppend, Oven%A_Index%: %Temp1%`, %Temp2%`n, debug.txt 
}

;At this point we found all the oven and hearth windows. Now let's find the lower left and lower right corners.
While((i:=A_Index) <= Ovens)
{
  ImageSearch, FoundX, , OvenX%i%, OvenY%i%, WindowWidth, OvenY%i% + 7, *60 upper_right_8x8.png
  If (ErrorLevel == 2)
  {
    MsgBox, upper_right_8x8.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    ;ToDo: Could try to find the lower right corner here instead of aborting.
    MsgBox, Could not find the upper right corner of oven %i%. Make sure no windows overlap.
    return
  }
  ;ErrorLevel == 0
  OvenWidth%i%:=FoundX - OvenX%i% + 8
  OvenEndX%i%:=FoundX + 8
  
  ImageSearch, , FoundY, OvenX%i%, OvenY%i%, OvenX%i% + 15, WindowHeight, *60 lower_left_16x16.png
  If (ErrorLevel == 2)
  {
    MsgBox, lower_left_16x16.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    ;ToDo: Could try to find the lower right corner here instead of aborting.
    MsgBox, Could not find the lower left corner of oven %i%. Make sure no windows overlap.
    return
  }
  ;ErrorLevel == 0
  OvenHeight%i%:=FoundY - OvenY%i% + 16
  OvenEndY%i%:=FoundY + 16
}

;Now that we know the dimension of the windows, let's find the Begin buttons.
While((i:=A_Index) <= Ovens)
{
  ImageSearch, FoundX, FoundY, OvenX%i%, OvenY%i%, OvenEndX%i%, OvenEndY%i%, *70 begin.png
  If (ErrorLevel == 2)
  {
    MsgBox, begin.png: Error opening file or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    ;ToDo: If button is being moused over
    MsgBox, Could not find the Begin button for oven %i%.
    return
  }
  ;ErrorLevel == 0
  OvenBeginX%i%:=FoundX
  OvenBeginY%i%:=FoundY
}

If (Ovens != "" && Ovens > 0)
{
  MsgBox, Found %Ovens% ovens/hearths. Hit Ctrl+Alt+Shift+`` (that's the tilde key) to begin.
}
else
{
  MsgBox, No ovens or hearths found!
  return
}

#IfWinActive, eGenesis Client ahk_class eGenesis Client

;Clicks the Begin buttons.
^+!`::
;Do some sanity checks first before starting.
If (Ovens == "" || Ovens <= 0)
{
  MsgBox, No ovens found. Aborting.
  return
}
While((i:=A_Index) <= Ovens)
{
  If (OvenX%i% == "" || OvenY%i% == "" || OvenBeginX%i% == "" || OvenBeginY%i% == "" || OvenEndX%i% == "" || OvenEndY%i% == "")
  {
    MsgBox, Oven %i%: Error found with oven parameters.
    return
  }
}

While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenBeginX%i%, OvenBeginY%i%, 1, 1)
}
return

;add wood
^a::
While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenX%i% + 36, OvenEndY%i% - 25, 1, 1)
}
return

;adds water
^w::
While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenX%i% + 85, OvenEndY%i% - 25, 1, 1)
}
return

;Sets vent to low
^1::
While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenX%i% + 131, OvenEndY%i% - 25, 1, 1)
}
return

;Sets vent to medium
^2::
While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenX%i% + 156, OvenEndY%i% - 25, 1, 1)
}
return

^3::
While((i:=A_Index) <= Ovens)
{
  ClickInstant(OvenX%i% + 181, OvenEndY%i% - 25, 1, 1)
}
return

^+#a::
MouseGetPos, MouseX, MouseY
OpenOvens++
OpenOvenX%OpenOvens%:=MouseX
OpenOvenY%OpenOvens%:=MouseY
return

^+!#o::
OpenWindows(226, 280, WindowWidth, WindowHeight)
return

OpenWindows(IntervalX, IntervalY, WindowWidth, WindowHeight, XStart=20, YStart=50, WaitTime=100)
{
  global
  local WindowsX:=(WindowWidth - XStart - 20)//IntervalX
  local WindowsY:=OpenOvens//WindowsX + 1

  Counter:=0
  Loop, %WindowsY%
  {
    i:=A_Index
    Loop, %WindowsX%
    {
      j:=A_Index
      Counter:=(i-1)*WindowsX + j
      If (Counter > OpenOvens)
        break
      MouseMove, XStart + (j-1)*IntervalX, YStart + (i-1)*IntervalY + IntervalY//2
      Sleep, WaitTime
      ClickInstant(OpenOvenX%Counter%, OpenOvenY%Counter%)
    }
    If (Counter > OpenOvens)
      break
  }
}

ClickInstant(X, Y, Button=2, WaitForMouse=0, TurnOnCritical=0)
{
  global ATITDWindow
  global TopLeftX
  global TopLeftY
  
  wParam1:=0x0204
  wParam2:=0x0205

  ;Button 1 is left click, 2 is right click
  If (Button == 1)
  {
    wParam1:=0x0201
    wParam2:=0x0202
  }

  If (WaitForMouse == 1)
  {
    KeyWait, LButton
    KeyWait, RButton
  }

  If (TurnOnCritical == 1)
  {
    Critical, On
  }

  Loop, 2
  {
    PostMessage, wParam%A_Index%, 0, X - TopLeftX + (Y - TopLeftY<<16), , %ATITDWindow%
  }

  If (TurnOnCritical == 1)
  {
    Critical, Off
  }
}


#IfWinActive
;Script macros here
^+!r::Reload
^+!e::Edit